%% hall3


%% read image

small_area = 200;
rgb = imread('pos5.jpg');
sz = size(rgb)
if length(sz)>2 
    g = im2double(rgb2gray(rgb));
else
    g = im2double(rgb);
end
imshow(rgb);

%%

black = g<0.3;
imshow(black);

%%

white = (g>0.5);
imshow(white);

%%

se1 = strel('square',7);
b1 = imdilate(black,se1);
w1 = imdilate(white,se1);
bw1 = w1&b1;
bw2 = bwareaopen(bw1,small_area);

imshow(bw2);

%%

CC = bwconncomp(bw2);
disp(CC);
L = labelmatrix(CC);
imshow(label2rgb(L));

%%

s = regionprops(CC,'Image','FilledImage','Area','EulerNumber');
areas = [s.Area];
[maxarea idx] = max(areas);
imshow(s(idx).Image);

%%

bw3 = s(idx).FilledImage&~s(idx).Image;
bw4 = bwareaopen(bw3,small_area);
CC2 = bwconncomp(bw4);
L2 = labelmatrix(CC2);
imshow(label2rgb(L2));

%%

s2 = regionprops(CC2,'Area','Centroid');

area = cat(1,s2.Area);
fprintf('number of squares %d\n',length(area));
fprintf('max area %d min area %d\n',max(area),min(area));
fprintf('Euler %d\n',-s(idx).EulerNumber);

%%

pts = reshape([s2.Centroid],2,length(s2));

plot(pts(1,:),pts(2,:),'ko');
hold off
axis ij
axis equal
grid

%%

rgbm = label2rgb(L,'jet','k');
mask = min(rgbm,[],3)==0;
gm = g.*mask;
rgbn = cat(3,gm,gm,gm)+im2double(rgbm);
imshow(rgbn);


